<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use JsonSerializable;

/**
 * Implementation for the base implementation of an entity: id, creation and last update date and time
 */
trait TEntityBase {
    /**
     * @var int|null The internal id
     *
     * @noinspection PhpPropertyNamingConventionInspection
     */
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    /**
     * Les données du trait qui doivent être inclus dans le JSON
     *
     * @return array Les données du trait qui doivent être inclus dans le JSON
     *
     * @see          JsonSerializable::jsonSerialize()
     *
     * @noinspection PhpMethodNamingConventionInspection
     */
    protected final function TEntityBase__jsonSerialize (): array {
        return [
            'id' => $this->getId(),
        ];
    }

    /**
     * The internal id
     *
     * @return int|null The internal id
     */
    public function getId (): ?int {
        return $this->id;
    }
}